Index: libcfa/src/concurrency/locks.cfa
===================================================================
--- libcfa/src/concurrency/locks.cfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/concurrency/locks.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -1,48 +1,38 @@
 #include "locks.hfa"
 #include "kernel_private.hfa"
+#include <stdlib.h>
+#include <stdio.h>
 
 #include <kernel.hfa>
 #include <stdlib.hfa>
-
-//-----------------------------------------------------------------------------
-// info_thread
+#include <thread.hfa>
+
+///////////////////////////////////////////////////////////////////
+//// info_thread
+///////////////////////////////////////////////////////////////////
+
 forall(dtype L | is_blocking_lock(L)) {
-	struct info_thread {
-		// used to put info_thread on a dl queue (aka sequence)
-		inline Seqable;
-
-		// waiting thread
-		struct $thread * t;
-
-		// shadow field
-		uintptr_t info;
-
-		// lock that is passed to wait() (if one is passed)
-		L * lock;
-
-		// true when signalled and false when timeout wakes thread
-		bool signalled;
-	};
-
-	void ?{}( info_thread(L) & this, $thread * t, uintptr_t info, L * l ) {
+	void ?{}( info_thread(L) & this, $thread * t ) {
+		((Seqable &) this){};
+		this.t = t;
+		this.lock = 0p;
+		this.listed = false;
+	}
+
+	void ?{}( info_thread(L) & this, $thread * t, uintptr_t info ) {
 		((Seqable &) this){};
 		this.t = t;
 		this.info = info;
-		this.lock = l;
-	}
-
-	void ^?{}( info_thread(L) & this ) {}
-
-	info_thread(L) *& Back( info_thread(L) * this ) {
-		return (info_thread(L) *)Back( (Seqable *)this );
-	}
-
-	info_thread(L) *& Next( info_thread(L) * this ) {
-		return (info_thread(L) *)Next( (Colable *)this );
-	}
-}
-
-//-----------------------------------------------------------------------------
-// Blocking Locks
+		this.lock = 0p;
+		this.listed = false;
+	}
+
+	void ^?{}( info_thread(L) & this ){ }
+}
+
+///////////////////////////////////////////////////////////////////
+//// Blocking Locks
+///////////////////////////////////////////////////////////////////
+
 void ?{}( blocking_lock & this, bool multi_acquisition, bool strict_owner ) {
 	this.lock{};
@@ -56,33 +46,25 @@
 
 void ^?{}( blocking_lock & this ) {}
-void  ?{}( single_acquisition_lock & this ) {((blocking_lock &)this){ false, false };}
+void ?{}( single_acquisition_lock & this ) {((blocking_lock &)this){ false, false };}
 void ^?{}( single_acquisition_lock & this ) {}
-void  ?{}( owner_lock & this ) {((blocking_lock &)this){ true, true };}
+void ?{}( owner_lock & this ) {((blocking_lock &)this){ true, true };}
 void ^?{}( owner_lock & this ) {}
-void  ?{}( multiple_acquisition_lock & this ) {((blocking_lock &)this){ true, false };}
+void ?{}( multiple_acquisition_lock & this ) {((blocking_lock &)this){ true, false };}
 void ^?{}( multiple_acquisition_lock & this ) {}
 
 void lock( blocking_lock & this ) with( this ) {
 	lock( lock __cfaabi_dbg_ctx2 );
-	$thread * thrd = active_thread();
-
-	// single acquisition lock is held by current thread
-	/* paranoid */ verifyf( owner != thrd || multi_acquisition, "Single acquisition lock holder (%p) attempted to reacquire the lock %p resulting in a deadlock.", owner, &this );
-
-	// lock is held by some other thread
-	if ( owner != 0p && owner != thrd ) {
-		addTail( blocked_threads, *thrd );
+	if ( owner == active_thread() && !multi_acquisition) {
+		abort("A single acquisition lock holder attempted to reacquire the lock resulting in a deadlock.");
+	} else if ( owner != 0p && owner != active_thread() ) {
+		append( blocked_threads, active_thread() );
 		wait_count++;
 		unlock( lock );
 		park( );
-	}
-	// multi acquisition lock is held by current thread
-	else if ( owner == thrd && multi_acquisition ) {
+	} else if ( owner == active_thread() && multi_acquisition ) {
 		recursion_count++;
 		unlock( lock );
-	}
-	// lock isn't held
-	else {
-		owner = thrd;
+	} else {
+		owner = active_thread();
 		recursion_count = 1;
 		unlock( lock );
@@ -93,23 +75,26 @@
 	bool ret = false;
 	lock( lock __cfaabi_dbg_ctx2 );
-
-	// lock isn't held
 	if ( owner == 0p ) {
 		owner = active_thread();
 		recursion_count = 1;
 		ret = true;
-	}
-	// multi acquisition lock is held by current thread
-	else if ( owner == active_thread() && multi_acquisition ) {
+	} else if ( owner == active_thread() && multi_acquisition ) {
 		recursion_count++;
 		ret = true;
 	}
-
 	unlock( lock );
 	return ret;
 }
 
+void unlock_error_check( blocking_lock & this ) with( this ) {
+	if ( owner == 0p ){ // no owner implies lock isn't held
+		abort( "There was an attempt to release a lock that isn't held" ); 
+	} else if ( strict_owner && owner != active_thread() ) {
+		abort( "A thread other than the owner attempted to release an owner lock" ); 
+	}
+}
+
 void pop_and_set_new_owner( blocking_lock & this ) with( this ) {
-	$thread * t = &dropHead( blocked_threads );
+	$thread * t = pop_head( blocked_threads );
 	owner = t;
 	recursion_count = ( t ? 1 : 0 );
@@ -120,8 +105,5 @@
 void unlock( blocking_lock & this ) with( this ) {
 	lock( lock __cfaabi_dbg_ctx2 );
-	/* paranoid */ verifyf( owner != 0p, "Attempt to release lock %p that isn't held", &this );
-	/* paranoid */ verifyf( owner == active_thread() || !strict_owner, "Thread %p other than the owner %p attempted to release owner lock %p", owner, active_thread(), &this );
-
-	// if recursion count is zero release lock and set new owner if one is waiting
+	unlock_error_check( this );
 	recursion_count--;
 	if ( recursion_count == 0 ) {
@@ -143,14 +125,11 @@
 }
 
-void on_notify( blocking_lock & this, $thread * t ) with( this ) {
-	lock( lock __cfaabi_dbg_ctx2 );
-	// lock held
+void add_( blocking_lock & this, $thread * t ) with( this ) {
+    lock( lock __cfaabi_dbg_ctx2 );
 	if ( owner != 0p ) {
-		addTail( blocked_threads, *t );
+		append( blocked_threads, t );
 		wait_count++;
 		unlock( lock );
-	}
-	// lock not held
-	else {
+	} else {
 		owner = t;
 		recursion_count = 1;
@@ -160,84 +139,62 @@
 }
 
-void on_wait( blocking_lock & this ) with( this ) {
-	lock( lock __cfaabi_dbg_ctx2 );
-	/* paranoid */ verifyf( owner != 0p, "Attempt to release lock %p that isn't held", &this );
-	/* paranoid */ verifyf( owner == active_thread() || !strict_owner, "Thread %p other than the owner %p attempted to release owner lock %p", owner, active_thread(), &this );
-
+void remove_( blocking_lock & this ) with( this ) {
+    lock( lock __cfaabi_dbg_ctx2 );
+	unlock_error_check( this );
 	pop_and_set_new_owner( this );
 	unlock( lock );
 }
 
-//-----------------------------------------------------------------------------
-// Overloaded routines for traits
-// These routines are temporary until an inheritance bug is fixed
-void   lock      ( single_acquisition_lock & this ) { lock   ( (blocking_lock &)this ); }
-void   unlock    ( single_acquisition_lock & this ) { unlock ( (blocking_lock &)this ); }
-void   on_wait   ( single_acquisition_lock & this ) { on_wait( (blocking_lock &)this ); }
-void   on_notify ( single_acquisition_lock & this, struct $thread * t ) { on_notify( (blocking_lock &)this, t ); }
-void   set_recursion_count( single_acquisition_lock & this, size_t recursion ) { set_recursion_count( (blocking_lock &)this, recursion ); }
-size_t get_recursion_count( single_acquisition_lock & this ) { return get_recursion_count( (blocking_lock &)this ); }
-
-void   lock     ( owner_lock & this ) { lock   ( (blocking_lock &)this ); }
-void   unlock   ( owner_lock & this ) { unlock ( (blocking_lock &)this ); }
-void   on_wait  ( owner_lock & this ) { on_wait( (blocking_lock &)this ); }
-void   on_notify( owner_lock & this, struct $thread * t ) { on_notify( (blocking_lock &)this, t ); }
-void   set_recursion_count( owner_lock & this, size_t recursion ) { set_recursion_count( (blocking_lock &)this, recursion ); }
-size_t get_recursion_count( owner_lock & this ) { return get_recursion_count( (blocking_lock &)this ); }
-
-void   lock     ( multiple_acquisition_lock & this ) { lock   ( (blocking_lock &)this ); }
-void   unlock   ( multiple_acquisition_lock & this ) { unlock ( (blocking_lock &)this ); }
-void   on_wait  ( multiple_acquisition_lock & this ) { on_wait( (blocking_lock &)this ); }
-void   on_notify( multiple_acquisition_lock & this, struct $thread * t ){ on_notify( (blocking_lock &)this, t ); }
-void   set_recursion_count( multiple_acquisition_lock & this, size_t recursion ){ set_recursion_count( (blocking_lock &)this, recursion ); }
+///////////////////////////////////////////////////////////////////
+//// Overloaded routines for traits
+///////////////////////////////////////////////////////////////////
+
+// This is temporary until an inheritance bug is fixed
+
+void lock( single_acquisition_lock & this ){ lock( (blocking_lock &)this ); }
+void unlock( single_acquisition_lock & this ){ unlock( (blocking_lock &)this ); }
+void add_( single_acquisition_lock & this, struct $thread * t ){ add_( (blocking_lock &)this, t ); }
+void remove_( single_acquisition_lock & this ){ remove_( (blocking_lock &)this ); }
+void set_recursion_count( single_acquisition_lock & this, size_t recursion ){ set_recursion_count( (blocking_lock &)this, recursion ); }
+size_t get_recursion_count( single_acquisition_lock & this ){ return get_recursion_count( (blocking_lock &)this ); }
+
+void lock( owner_lock & this ){ lock( (blocking_lock &)this ); }
+void unlock( owner_lock & this ){ unlock( (blocking_lock &)this ); }
+void add_( owner_lock & this, struct $thread * t ){ add_( (blocking_lock &)this, t ); }
+void remove_( owner_lock & this ){ remove_( (blocking_lock &)this ); }
+void set_recursion_count( owner_lock & this, size_t recursion ){ set_recursion_count( (blocking_lock &)this, recursion ); }
+size_t get_recursion_count( owner_lock & this ){ return get_recursion_count( (blocking_lock &)this ); }
+
+void lock( multiple_acquisition_lock & this ){ lock( (blocking_lock &)this ); }
+void unlock( multiple_acquisition_lock & this ){ unlock( (blocking_lock &)this ); }
+void add_( multiple_acquisition_lock & this, struct $thread * t ){ add_( (blocking_lock &)this, t ); }
+void remove_( multiple_acquisition_lock & this ){ remove_( (blocking_lock &)this ); }
+void set_recursion_count( multiple_acquisition_lock & this, size_t recursion ){ set_recursion_count( (blocking_lock &)this, recursion ); }
 size_t get_recursion_count( multiple_acquisition_lock & this ){ return get_recursion_count( (blocking_lock &)this ); }
 
-//-----------------------------------------------------------------------------
-// alarm node wrapper
+///////////////////////////////////////////////////////////////////
+//// condition variable
+///////////////////////////////////////////////////////////////////
+
 forall(dtype L | is_blocking_lock(L)) {
-	struct alarm_node_wrap {
-		alarm_node_t alarm_node;
-		condition_variable(L) * cond;
-		info_thread(L) * i;
-	};
-
-	void ?{}( alarm_node_wrap(L) & this, Time alarm, Duration period, Alarm_Callback callback, condition_variable(L) * c, info_thread(L) * i ) {
-		this.alarm_node{ callback, alarm, period };
-		this.cond = c;
-		this.i = i;
-	}
-
-	void ^?{}( alarm_node_wrap(L) & this ) { }
 
 	void timeout_handler ( alarm_node_wrap(L) & this ) with( this ) {
-		// This condition_variable member is called from the kernel, and therefore, cannot block, but it can spin.
-		lock( cond->lock __cfaabi_dbg_ctx2 );
-
-		// this check is necessary to avoid a race condition since this timeout handler
-		// 	may still be called after a thread has been removed from the queue but
-		// 	before the alarm is unregistered
-		if ( listed(i) ) {	// is thread on queue
-			i->signalled = false;
-			// remove this thread O(1)
-			remove( cond->blocked_threads, *i );
+    	// This condition_variable member is called from the kernel, and therefore, cannot block, but it can spin.
+	    lock( cond->lock __cfaabi_dbg_ctx2 );
+	    
+	    if ( i->listed ) {			// is thread on queue
+	    	cond->last_thread = i;		// REMOVE THIS AFTER DEBUG
+			remove( cond->blocked_threads, *i );		 //remove this thread O(1)
 			cond->count--;
-			if( i->lock ) {
-				// call lock's on_notify if a lock was passed
-				on_notify(*i->lock, i->t);
-			} else {
-				// otherwise wake thread
+			if( !i->lock ) {
 				unpark( i->t );
-			}
-		}
-		unlock( cond->lock );
-	}
-
-	// this casts the alarm node to our wrapped type since we used type erasure
+	    	} else {
+	    		add_(*i->lock, i->t);			// call lock's add_
+	    	}
+	    }
+	    unlock( cond->lock );
+	}
+
 	void alarm_node_wrap_cast( alarm_node_t & a ) { timeout_handler( (alarm_node_wrap(L) &)a ); }
-}
-
-//-----------------------------------------------------------------------------
-// condition variable
-forall(dtype L | is_blocking_lock(L)) {
 
 	void ?{}( condition_variable(L) & this ){
@@ -245,17 +202,22 @@
 		this.blocked_threads{};
 		this.count = 0;
+		this.last_thread = 0p; // REMOVE AFTER DEBUG
 	}
 
 	void ^?{}( condition_variable(L) & this ){ }
+
+	void ?{}( alarm_node_wrap(L) & this, Time alarm, Duration period, Alarm_Callback callback ) {
+		this.alarm_node{ callback, alarm, period };
+	}
+
+	void ^?{}( alarm_node_wrap(L) & this ) { }
 
 	void process_popped( condition_variable(L) & this, info_thread(L) & popped ) with( this ) {
 		if(&popped != 0p) {
-			popped.signalled = true;
+			popped.listed = false;
 			count--;
 			if (popped.lock) {
-				// if lock passed call on_notify
-				on_notify(*popped.lock, popped.t);
+				add_(*popped.lock, popped.t);
 			} else {
-				// otherwise wake thread
 				unpark(popped.t);
 			}
@@ -290,12 +252,12 @@
 
 	size_t queue_and_get_recursion( condition_variable(L) & this, info_thread(L) * i ) with(this) {
-		// add info_thread to waiting queue
 		addTail( blocked_threads, *i );
 		count++;
+		i->listed = true;
 		size_t recursion_count = 0;
 		if (i->lock) {
-			// if lock was passed get recursion count to reset to after waking thread
+			i->t->link.next = 1p;
 			recursion_count = get_recursion_count(*i->lock);
-			on_wait( *i->lock );
+			remove_( *i->lock );
 		}
 		return recursion_count;
@@ -307,15 +269,7 @@
 		size_t recursion_count = queue_and_get_recursion(this, &i);
 		unlock( lock );
-
-		// blocks here
-		park( );
-
-		// resets recursion count here after waking
-		if (i.lock) set_recursion_count(*i.lock, recursion_count);
-	}
-
-	#define WAIT( u, l ) \
-		info_thread( L ) i = { active_thread(), u, l }; \
-		queue_info_thread( this, i );
+		park( ); // blocks here
+		if (i.lock) set_recursion_count(*i.lock, recursion_count); // resets recursion count here after waking
+	}
 
 	// helper for wait()'s' with a timeout
@@ -323,35 +277,78 @@
 		lock( lock __cfaabi_dbg_ctx2 );
 		size_t recursion_count = queue_and_get_recursion(this, &info);
-		alarm_node_wrap(L) node_wrap = { t, 0`s, alarm_node_wrap_cast, &this, &info };
+		alarm_node_wrap(L) node_wrap = { t, 0`s, alarm_node_wrap_cast };
+		node_wrap.cond = &this;
+		node_wrap.i = &info;
 		register_self( &node_wrap.alarm_node );
 		unlock( lock );
-
-		// blocks here
 		park();
-
-		// unregisters alarm so it doesn't go off if this happens first
 		unregister_self( &node_wrap.alarm_node );
-
-		// resets recursion count here after waking
 		if (info.lock) set_recursion_count(*info.lock, recursion_count);
 	}
 
-	#define WAIT_TIME( u, l, t ) \
-		info_thread( L ) i = { active_thread(), u, l }; \
-		queue_info_thread_timeout(this, i, t ); \
-		return i.signalled;
-
-	void wait( condition_variable(L) & this                        ) with(this) { WAIT( 0, 0p    ) }
-	void wait( condition_variable(L) & this, uintptr_t info        ) with(this) { WAIT( info, 0p ) }
-	void wait( condition_variable(L) & this, L & l                 ) with(this) { WAIT( 0, &l    ) }
-	void wait( condition_variable(L) & this, L & l, uintptr_t info ) with(this) { WAIT( info, &l ) }
-
-	bool wait( condition_variable(L) & this, Duration duration                        ) with(this) { WAIT_TIME( 0   , 0p , __kernel_get_time() + duration ) }
-	bool wait( condition_variable(L) & this, uintptr_t info, Duration duration        ) with(this) { WAIT_TIME( info, 0p , __kernel_get_time() + duration ) }
-	bool wait( condition_variable(L) & this, Time time                                ) with(this) { WAIT_TIME( 0   , 0p , time ) }
-	bool wait( condition_variable(L) & this, uintptr_t info, Time time                ) with(this) { WAIT_TIME( info, 0p , time ) }
-	bool wait( condition_variable(L) & this, L & l, Duration duration                 ) with(this) { WAIT_TIME( 0   , &l , __kernel_get_time() + duration ) }
-	bool wait( condition_variable(L) & this, L & l, uintptr_t info, Duration duration ) with(this) { WAIT_TIME( info, &l , __kernel_get_time() + duration ) }
-	bool wait( condition_variable(L) & this, L & l, Time time                         ) with(this) { WAIT_TIME( 0   , &l , time ) }
-	bool wait( condition_variable(L) & this, L & l, uintptr_t info, Time time         ) with(this) { WAIT_TIME( info, &l , time ) }
-}
+	void wait( condition_variable(L) & this ) with(this) {
+		info_thread( L ) i = { active_thread() };
+		queue_info_thread( this, i );
+	}
+
+	void wait( condition_variable(L) & this, uintptr_t info ) with(this) {
+		info_thread( L ) i = { active_thread(), info };
+		queue_info_thread( this, i );
+	}
+	
+	void wait( condition_variable(L) & this, Duration duration ) with(this) {
+		info_thread( L ) i = { active_thread() };
+		queue_info_thread_timeout(this, i, __kernel_get_time() + duration );
+	}
+
+	void wait( condition_variable(L) & this, uintptr_t info, Duration duration ) with(this) { 
+		info_thread( L ) i = { active_thread(), info };
+		queue_info_thread_timeout(this, i, __kernel_get_time() + duration );
+	}
+
+	void wait( condition_variable(L) & this, Time time ) with(this) {
+		info_thread( L ) i = { active_thread() };
+		queue_info_thread_timeout(this, i, time);
+	}
+
+	void wait( condition_variable(L) & this, uintptr_t info, Time time ) with(this) {
+		info_thread( L ) i = { active_thread(), info };
+		queue_info_thread_timeout(this, i, time);
+	}
+
+	void wait( condition_variable(L) & this, L & l ) with(this) {
+		info_thread(L) i = { active_thread() };
+		i.lock = &l;
+		queue_info_thread( this, i );
+	}
+
+	void wait( condition_variable(L) & this, L & l, uintptr_t info ) with(this) {
+		info_thread(L) i = { active_thread(), info };
+		i.lock = &l;
+		queue_info_thread( this, i );
+	}
+	
+	void wait( condition_variable(L) & this, L & l, Duration duration ) with(this) {
+		info_thread(L) i = { active_thread() };
+		i.lock = &l;
+		queue_info_thread_timeout(this, i, __kernel_get_time() + duration );
+	}
+	
+	void wait( condition_variable(L) & this, L & l, uintptr_t info, Duration duration ) with(this) {
+		info_thread(L) i = { active_thread(), info };
+		i.lock = &l;
+		queue_info_thread_timeout(this, i, __kernel_get_time() + duration );
+	}
+	
+	void wait( condition_variable(L) & this, L & l, Time time ) with(this) {
+		info_thread(L) i = { active_thread() };
+		i.lock = &l;
+		queue_info_thread_timeout(this, i, time );
+	}
+	
+	void wait( condition_variable(L) & this, L & l, uintptr_t info, Time time ) with(this) {
+		info_thread(L) i = { active_thread(), info };
+		i.lock = &l;
+		queue_info_thread_timeout(this, i, time );
+	}
+}
Index: libcfa/src/concurrency/locks.hfa
===================================================================
--- libcfa/src/concurrency/locks.hfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/concurrency/locks.hfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -3,6 +3,8 @@
 #include <stdbool.h>
 
+#include "bits/algorithm.hfa"
 #include "bits/locks.hfa"
 #include "bits/sequence.hfa"
+#include "bits/containers.hfa"
 
 #include "invoke.h"
@@ -10,35 +12,51 @@
 #include "time_t.hfa"
 #include "time.hfa"
+#include <sys/time.h>
+#include "alarm.hfa"
 
-//-----------------------------------------------------------------------------
-// is_blocking_lock
+///////////////////////////////////////////////////////////////////
+//// is_blocking_lock
+///////////////////////////////////////////////////////////////////
+
 trait is_blocking_lock(dtype L | sized(L)) {
-	// For synchronization locks to use when acquiring
-	void on_notify( L &, struct $thread * );
-
-	// For synchronization locks to use when releasing
-	void on_wait( L & );
-
-	// to get recursion count for cond lock to reset after waking
-	size_t get_recursion_count( L & );
-
-	// to set recursion count after getting signalled;
-	void set_recursion_count( L &, size_t recursion );
+	void add_( L &, struct $thread * );		// For synchronization locks to use when acquiring
+	void remove_( L & );    // For synchronization locks to use when releasing
+	size_t get_recursion_count( L & ); // to get recursion count for cond lock to reset after waking
+	void set_recursion_count( L &, size_t recursion ); // to set recursion count after getting signalled;
 };
 
-//-----------------------------------------------------------------------------
-// info_thread
-// the info thread is a wrapper around a thread used
-// to store extra data for use in the condition variable
+///////////////////////////////////////////////////////////////////
+//// info_thread
+///////////////////////////////////////////////////////////////////
+
 forall(dtype L | is_blocking_lock(L)) {
-	struct info_thread;
+	struct info_thread {
+		inline Seqable;
+		struct $thread * t;
+		uintptr_t info;
+		L * lock;
+		bool listed;					// true if info_thread is on queue, false otherwise;
+	};
 
-	// for use by sequence
-	info_thread(L) *& Back( info_thread(L) * this );
-	info_thread(L) *& Next( info_thread(L) * this );
+
+	void ?{}( info_thread(L) & this, $thread * t );
+	void ?{}( info_thread(L) & this, $thread * t, uintptr_t info );
+	void ^?{}( info_thread(L) & this );
 }
 
-//-----------------------------------------------------------------------------
-// Blocking Locks
+///////////////////////////////////////////////////////////////////
+//// Blocking Locks
+///////////////////////////////////////////////////////////////////
+
+// struct lock_thread {
+// 	struct $thread * t;
+// 	lock_thread * next;
+// };
+
+// void ?{}( lock_thread & this, struct $thread * thd );
+// void ^?{}( lock_thread & this );
+
+// lock_thread *& get_next( lock_thread & );
+
 struct blocking_lock {
 	// Spin lock used for mutual exclusion
@@ -46,5 +64,5 @@
 
 	// List of blocked threads
-	Sequence( $thread ) blocked_threads;
+	__queue_t( $thread ) blocked_threads;
 
 	// Count of current blocked threads
@@ -76,14 +94,14 @@
 };
 
-void  ?{}( blocking_lock & this, bool multi_acquisition, bool strict_owner );
+void ?{}( blocking_lock & this, bool multi_acquisition, bool strict_owner );
 void ^?{}( blocking_lock & this );
 
-void  ?{}( single_acquisition_lock & this );
+void ?{}( single_acquisition_lock & this );
 void ^?{}( single_acquisition_lock & this );
 
-void  ?{}( owner_lock & this );
+void ?{}( owner_lock & this );
 void ^?{}( owner_lock & this );
 
-void  ?{}( multiple_acquisition_lock & this );
+void ?{}( multiple_acquisition_lock & this );
 void ^?{}( multiple_acquisition_lock & this );
 
@@ -91,6 +109,6 @@
 bool try_lock( blocking_lock & this );
 void unlock( blocking_lock & this );
-void on_notify( blocking_lock & this, struct $thread * t );
-void on_wait( blocking_lock & this );
+void add_( blocking_lock & this, struct $thread * t );
+void remove_( blocking_lock & this );
 size_t wait_count( blocking_lock & this );
 void set_recursion_count( blocking_lock & this, size_t recursion );
@@ -99,6 +117,6 @@
 void lock( single_acquisition_lock & this );
 void unlock( single_acquisition_lock & this );
-void on_notify( single_acquisition_lock & this, struct $thread * t );
-void on_wait( single_acquisition_lock & this );
+void add_( single_acquisition_lock & this, struct $thread * t );
+void remove_( single_acquisition_lock & this );
 void set_recursion_count( single_acquisition_lock & this, size_t recursion );
 size_t get_recursion_count( single_acquisition_lock & this );
@@ -106,6 +124,6 @@
 void lock( owner_lock & this );
 void unlock( owner_lock & this );
-void on_notify( owner_lock & this, struct $thread * t );
-void on_wait( owner_lock & this );
+void add_( owner_lock & this, struct $thread * t );
+void remove_( owner_lock & this );
 void set_recursion_count( owner_lock & this, size_t recursion );
 size_t get_recursion_count( owner_lock & this );
@@ -113,15 +131,18 @@
 void lock( multiple_acquisition_lock & this );
 void unlock( multiple_acquisition_lock & this );
-void on_notify( multiple_acquisition_lock & this, struct $thread * t );
-void on_wait( multiple_acquisition_lock & this );
+void add_( multiple_acquisition_lock & this, struct $thread * t );
+void remove_( multiple_acquisition_lock & this );
 void set_recursion_count( multiple_acquisition_lock & this, size_t recursion );
 size_t get_recursion_count( multiple_acquisition_lock & this );
 
-//-----------------------------------------------------------------------------
-// Synchronization Locks
+///////////////////////////////////////////////////////////////////
+//// Synchronization Locks
+///////////////////////////////////////////////////////////////////
 forall(dtype L | is_blocking_lock(L)) {
 	struct condition_variable {
 		// Spin lock used for mutual exclusion
 		__spinlock_t lock;
+
+		info_thread(L) * last_thread;
 
 		// List of blocked threads
@@ -132,6 +153,21 @@
 	};
 
-	void  ?{}( condition_variable(L) & this );
+	void ?{}( condition_variable(L) & this );
 	void ^?{}( condition_variable(L) & this );
+
+	struct alarm_node_wrap {
+		alarm_node_t alarm_node;
+
+		condition_variable(L) * cond;
+
+		info_thread(L) * i;
+	};
+
+	void ?{}( alarm_node_wrap(L) & this, Time alarm, Duration period, Alarm_Callback callback );
+	void ^?{}( alarm_node_wrap(L) & this );
+
+	void alarm_node_callback( alarm_node_wrap(L) & this );
+
+	void alarm_node_wrap_cast( alarm_node_t & a );
 
 	bool notify_one( condition_variable(L) & this );
@@ -140,19 +176,20 @@
 	uintptr_t front( condition_variable(L) & this );
 
-	bool empty  ( condition_variable(L) & this );
-	int  counter( condition_variable(L) & this );
+	bool empty( condition_variable(L) & this );
+	int counter( condition_variable(L) & this );
 
+	// TODO: look into changing timout routines to return bool showing if signalled or woken by kernel
 	void wait( condition_variable(L) & this );
 	void wait( condition_variable(L) & this, uintptr_t info );
-	bool wait( condition_variable(L) & this, Duration duration );
-	bool wait( condition_variable(L) & this, uintptr_t info, Duration duration );
-	bool wait( condition_variable(L) & this, Time time );
-	bool wait( condition_variable(L) & this, uintptr_t info, Time time );
+	void wait( condition_variable(L) & this, Duration duration );
+	void wait( condition_variable(L) & this, uintptr_t info, Duration duration );
+	void wait( condition_variable(L) & this, Time time );
+	void wait( condition_variable(L) & this, uintptr_t info, Time time );
 
 	void wait( condition_variable(L) & this, L & l );
 	void wait( condition_variable(L) & this, L & l, uintptr_t info );
-	bool wait( condition_variable(L) & this, L & l, Duration duration );
-	bool wait( condition_variable(L) & this, L & l, uintptr_t info, Duration duration );
-	bool wait( condition_variable(L) & this, L & l, Time time );
-	bool wait( condition_variable(L) & this, L & l, uintptr_t info, Time time );
+	void wait( condition_variable(L) & this, L & l, Duration duration );
+	void wait( condition_variable(L) & this, L & l, uintptr_t info, Duration duration );
+	void wait( condition_variable(L) & this, L & l, Time time );
+	void wait( condition_variable(L) & this, L & l, uintptr_t info, Time time );
 }
Index: libcfa/src/concurrency/monitor.hfa
===================================================================
--- libcfa/src/concurrency/monitor.hfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/concurrency/monitor.hfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -132,8 +132,7 @@
 
               void wait        ( condition & this, uintptr_t user_info = 0 );
-static inline bool is_empty    ( condition & this ) { return this.blocked.head == 1p; }
               bool signal      ( condition & this );
               bool signal_block( condition & this );
-static inline bool signal_all  ( condition & this ) { bool ret = false; while(!is_empty(this)) { ret = signal(this) || ret; } return ret; }
+static inline bool is_empty    ( condition & this ) { return this.blocked.head == 1p; }
          uintptr_t front       ( condition & this );
 
Index: libcfa/src/concurrency/thread.cfa
===================================================================
--- libcfa/src/concurrency/thread.cfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/concurrency/thread.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -43,7 +43,4 @@
 		canary = 0x0D15EA5E0D15EA5Ep;
 	#endif
-
-	seqable.next = 0p;
-	seqable.back = 0p;
 
 	node.next = 0p;
@@ -133,5 +130,5 @@
 
 	this_thrd->context.[SP, FP] = this_thrd->self_cor.context.[SP, FP];
-	/* paranoid */ verify( this_thrd->context.SP );
+	verify( this_thrd->context.SP );
 
 	__schedule_thread( this_thrd );
